<?php

/**
 * resultado_remate actions.
 *
 * @package    cobro_coactivo
 * @subpackage resultado_remate
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class resultado_remateActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_RESULTADO_REMATE', 'CBR_APRUEBA_REMATE',
        'CBR_REMATE', 'CBR_SECUESTRO',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V', 'CBR_TIPO_REMATE'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_APRUEBA_REMATE' =>
        array(
            'id_aprueba_remate' => 'CBR_RESULTADO_REMATE'
        ),
        'CBR_REMATE' =>
        array(
            'id_remate' => 'CBR_APRUEBA_REMATE'
        ),
        'CBR_SECUESTRO' =>
        array(
            'id_secuestro' => 'CBR_REMATE'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'CBR_SECUESTRO'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_TIPO_REMATE' =>
        array(
            'id_tipo_remate' => 'CBR_RESULTADO_REMATE'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_RESULTADO_REMATE' =>
        array(
            'id_resultado_remate' => 'id_resultado_remate',
            'id_aprueba_remate' => 'id_aprueba_remate',
            'id_tipo_remate' => 'id_tipo_remate',
            'no_acta' => 'no_acta',
            'fecha' => 'fecha',
            'detalle_plantilla' => 'detalle_plantilla',
            'observaciones' => 'observaciones',
            'adjunto' => 'adjunto'
        ),
        'CBR_APRUEBA_REMATE' =>
        array(
            'id_remate' => 'id_remate',
            'no_acta' => 'acta_aprueba'
        ),
        'CBR_REMATE' =>
        array(
            'id_secuestro' => 'id_secuestro',
            'no_auto' => 'auto_remate',
            'fecha_remate' => 'fecha_remate'
        ),
        'CBR_SECUESTRO' =>
        array(
            'id_remision_titulo' => 'id_remision_titulo',
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado',
            'cod_titulo' => 'cod_titulo'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral'
        ),
        'CBR_TIPO_REMATE' =>
        array(
            'descripcion' => 'descripcion_tipo'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_RESULTADO_REMATE' =>
        array(
            'id_resultado_remate,a' => array('!=' => array(-1)),
            'id_resultado_remate,b' => array('=' => array('id_resultado_remate')),
            'id_aprueba_remate' => array('=' => array('id_aprueba_remate')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'cod_titulo' => array('=' => array('cod_titulo')),
            'anho_remision' => array('=' => array('anho_remision'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_resultado_remate'; //identificador de la tabla
    protected $id_names = array('id_resultado_remate'); //llave primaria
    protected $field_names = array('id_aprueba_remate', 'id_tipo_remate', 'no_acta', 'fecha', 'detalle_plantilla', 'observaciones', 'adjunto'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_RESULTADO_REMATE'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_resultado_remate'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {
                $id_resultado_remate = $list_data_post[0]['id_resultado_remate'];

                if ($request['id_plantilla'] != "") {
                    $id_plantilla = $request['id_plantilla'];
                    $sql = <<<EOD
UPDATE CBR_RESULTADO_REMATE SET DETALLE_PLANTILLA=(select detalle from cbr_plantilla where id_plantilla = $id_plantilla) where id_resultado_remate=$id_resultado_remate
EOD;


                    $this->conn->execute($sql);
                }


                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];


            $id_tipo_documento = 2; //ACTA


            $sql = <<<EOD
select consecutivo from cbr_consecutivo_doc where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $consecutivo = $records[0]['consecutivo'];

            $request['no_acta'] = $consecutivo;

            $sql = <<<EOD
update cbr_consecutivo_doc set consecutivo =($consecutivo+1) where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;

            CN_TABLE::executeSQL($sql);
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
